#ifndef MAP_H
#define MAP_H 

extern const int dim_x;
extern const int dim_y;

#include <stdbool.h>
#include "item.h"

#define EARTH 0
#define WATER 1
#define MOUNTAIN 2

struct generic_map // map à l'échelle d'un point
{
    int terrain;
    bool explored; // brouillard de guerre
    generic_item item;
};
typedef struct generic_map generic_map;



void create_map();

// hidden true, shown false
bool get_visibility(int x, int y);
int get_terrain(int x,int y);

generic_item* get_item(int x, int y);
void set_item(int x, int y, generic_item const * const item);

void display();

#endif